﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Dienstfahrten.Klassen;
using Dienstfahrten.ControlTemplates.Dienstfahrten;

namespace Dienstfahrten.Dienstfahrten
{
    [ToolboxItemAttribute(false)]
    public class Dienstfahrten : WebPart, IPostBackEventHandler
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        public const string _dienstfahrt = @"~/_CONTROLTEMPLATES/Dienstfahrten/Dienstfahrten/DienstfahrtenUserControl.ascx";
        public const string _dienstfahrtListe = @"~/_CONTROLTEMPLATES/Dienstfahrten/DienstfahrtenListeUserControl.ascx";
        public const string _konfiguration = @"~/_CONTROLTEMPLATES/Dienstfahrten/KonfigurationUserControl.ascx";
        public const string _menu = @"~/_CONTROLTEMPLATES/Dienstfahrten/menuUserControl.ascx";
        string loadUserControl;

        protected override void CreateChildControls()
        {
            CssRegistration.Register("/_layouts/Dienstfahrten/dienstfahrten.css");
            ClientScriptManager cs = Page.ClientScript;
            if (!cs.IsClientScriptIncludeRegistered("MD-Technologie"))
                cs.RegisterClientScriptInclude("MD-Technologie", "/_layouts/Dienstfahrten/MD-Technologie.js");

            //Testen ob die Listen existieren und die Datenobjekte erstellt werden können
            try
            {
                Konfiguration konf = new Konfiguration(SPContext.Current.Web);
                Dienstfahrt df = new Dienstfahrt(SPContext.Current.Web);

                //Control control = Page.LoadControl(_menu);
                menuUserControl menuControl = (menuUserControl)Page.LoadControl(_menu);
                KonfigurationUserControl konfControl = (KonfigurationUserControl)Page.LoadControl(_konfiguration);
                DienstfahrtenListeUserControl dlControl = (DienstfahrtenListeUserControl)Page.LoadControl(_dienstfahrtListe);
                DienstfahrtenUserControl dfControl = (DienstfahrtenUserControl)Page.LoadControl(_dienstfahrt);

                menuControl.menuControl = Controls;
                menuControl.konfControl = konfControl;
                menuControl.dfControl = dfControl;
                menuControl.dlControl = dlControl;
                Controls.Add(menuControl);
                Controls.Add(konfControl);
                Controls.Add(dfControl);
                Controls.Add(dlControl);
                menuControl.loadData(SPContext.Current.Web);

            }
            catch (Exception ex)
            {
                Controls.Add(new Label { Text = "No Dienstfahrten SharePoint list(s) found. Please activate Site-Feature 'Dienstfahrten Listen'!" });
            }

            
        }



        //http://stackoverflow.com/questions/9945148/sharepoint-webpart-with-many-usercontrols
        void IPostBackEventHandler.RaisePostBackEvent(string eventArgument) {
            if (eventArgument == "test") { // Recognize and handle our postback.
                loadUserControl = _konfiguration;
            }
        }

    }
}
