﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;
using Dienstfahrten.Logging;

namespace Dienstfahrten.Klassen
{
    interface IListe
    {
        //Statischer Name der Liste
        string ListName { get; }
        SPWeb currentWeb { get; }
        SPList currentList { get; }
        List<Object> ObjList { get; }


        /// <summary>
        /// Liefert alle Einträge aus der Liste
        /// </summary>
        /// <returns>Liste mit allen Einträgen</returns>
        List<Object> getList();

        /// <summary>
        /// Liefert Einträge aus der Liste anhand der übergebenen Parameter
        /// </summary>
        /// <param name="query">Filterparameter</param>
        /// <returns>Liste mit Einträgen</returns>
        List<Object> getListbyParam(params string[] query);
    }
}
